| Disk ARchive 2.6.11 Full featured and portable backup and archiving tool

Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::zapette Class Reference
Private

zapette emulate a file that is remotely controlled by slave_zapette More...

`#include <zapette.hpp>`

Inherits libdar::generic_file, libdar::contextual, and libdar::mem_ui.

## Public Member Functions
| zapette (const std::shared_ptr< user_interaction > &dialog, generic_file *input, generic_file *output, bool by_the_end)
| zapette constructor More...
| zapette (const zapette &ref)=default
| zapette (zapette &&ref) noexcept=default
zapette & | operator= (const zapette &ref)=default
zapette & | operator= (zapette &&ref) noexcept=default
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip More...
virtual bool | skip (const infinint &pos) override
| skip at the absolute position More...
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual infinint | get_position () const override
| get the current read/write position
virtual void | set_info_status (const std::string &s) override
| defines the new contextual value More...
virtual bool | is_an_old_start_end_archive () const override
| returns whether the archive is a old archive (format < 8)
virtual const label & | get_data_name () const override
| obtain the data_name of the archive (label associated with the archive's data) More...
infinint | get_first_slice_header_size () const
infinint | get_non_first_slice_header_size () const
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor, More...
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file More...
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data More...
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument More...
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data More...
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset More...
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor More...
Public Member Functions inherited from libdar::contextual
| contextual (const contextual &ref)=default
| contextual (contextual &&ref) noexcept=default
contextual & | operator= (const contextual &ref)=default
contextual & | operator= (contextual &&ref) noexcept=default
virtual std::string | get_info_status () const
| get the current contextual value

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data More...
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation More...
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation More...
virtual void | inherited_sync_write () override
| write down any pending data More...
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position More...
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions More...
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const
Protected Member Functions inherited from libdar::mem_ui
user_interaction & | get_ui () const
| get access to the user_interaction object More...
std::shared_ptr< user_interaction > | get_pointer () const
| get access to the shared_ptr pointing to the user_interaction
| mem_ui (const std::shared_ptr< user_interaction > &dialog)
| constructor More...
| mem_ui (const mem_ui &ref)=default
| the copy constructor More...
| mem_ui (mem_ui &&ref) noexcept=default
| the move constructor
mem_ui & | operator= (const mem_ui &ref)=default
| assignement operator More...
mem_ui & | operator= (mem_ui &&ref) noexcept=default
| move operator
virtual | ~mem_ui () noexcept(false)
| destructor More...

## Private Member Functions
void | make_transfert (U_16 size, const infinint &offset, char *data, const std::string &info, S_I &lu, infinint &arg) const
| wrapped formatted method to communicate with the slave_zapette located behind the pair of pipes (= tuyau) More...

## Private Attributes
generic_file * | in
generic_file * | out
infinint | position
infinint | file_size
char | serial_counter

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward, skip_forward }

## Detailed Description

zapette emulate a file that is remotely controlled by slave_zapette

class zapette sends order to slave_zapette through a a first pipe and receive informations or data in return from a second pipe from slave_zapette

Definition at line 55 of file zapette.hpp.

## Constructor & Destructor Documentation

## ◆ zapette()

libdar::zapette::zapette | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | generic_file * | input,
|  | generic_file * | output,
|  | bool | by_the_end
| ) |  |

zapette constructor

Parameters

  [in] | dialog | is used to return status information to the user
  [in] | input | is the pipe (see class tuyau) from which is received the information or data
  [in] | output | is used to send orders to slave_zapette
  [in] | by_the_end | if true dar will try to open the archive starting from the end else it will try starting from the first bytes

## Member Function Documentation

## ◆ get_data_name()

virtual const label& libdar::zapette::get_data_name | ( |  | ) | const
| override virtual

obtain the data_name of the archive (label associated with the archive's data)

Note
  label are conserved with dar_xform and archive isolation, but are not with archive merging or archive creation (full or differential backup)

Implements libdar::contextual.

## ◆ get_first_slice_header_size()

infinint libdar::zapette::get_first_slice_header_size | ( |  | ) | const

get the first slice header

Note
  may return 0 if the slice header is not known

## ◆ get_non_first_slice_header_size()

infinint libdar::zapette::get_non_first_slice_header_size | ( |  | ) | const

get the non first slice header

Note
  may return 0 if the slice header is not known

## ◆ inherited_flush_read()

virtual void libdar::zapette::inherited_flush_read | ( |  | ) |
| inline override protected virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 99 of file zapette.hpp.

## ◆ inherited_read()

virtual U_I libdar::zapette::inherited_read | ( | char * | a,
|  | U_I | size
| ) |  |
| override protected virtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

## ◆ inherited_read_ahead()

virtual void libdar::zapette::inherited_read_ahead | ( | const infinint & | amount | ) |
| inline override protected virtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

Definition at line 95 of file zapette.hpp.

## ◆ inherited_sync_write()

virtual void libdar::zapette::inherited_sync_write | ( |  | ) |
| inline override protected virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 98 of file zapette.hpp.

## ◆ inherited_terminate()

virtual void libdar::zapette::inherited_terminate | ( |  | ) |
| override protected virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

## ◆ inherited_write()

virtual void libdar::zapette::inherited_write | ( | const char * | a,
|  | U_I | size
| ) |  |
| override protected virtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

## ◆ make_transfert()

void libdar::zapette::make_transfert | ( | U_16 | size,
|  | const infinint & | offset,
|  | char * | data,
|  | const std::string & | info,
|  | S_I & | lu,
|  | infinint & | arg
| ) |  | const
| private

wrapped formatted method to communicate with the slave_zapette located behind the pair of pipes (= tuyau)

Parameters

  [in] | size | is the size of the amount of data we want the zapette to send us
  [in] | offset | is the byte offset of the portion of the data we want
  [in,out] | data | is the location where to return the requested data
  [in] | info | the new contextual string to set to the slave_zapette.
  [out] | lu | the amount of byte wrote to '*data'
  [out] | arg | infinint value return for special order (see note below).

Note
  with default parameters, this method permits the caller to get a portion of data from the remote slave_zapette. In addition, it let the caller change the 'contextual' status of the remote object. if size is set to REQUEST_SPECIAL_ORDER, the offset is used to transmit a special order to the remote slave_zapette. Defined order are for example REQUEST_OFFSET_END_TRANSMIT , REQUEST_OFFSET_GET_FILESIZE, and so on (see at the beginning of zapette.cpp file for more). Each of these order may expect a returned value which may be an integer (provided by the "arg" argument of this call) a boolean value (provided by the "arg" argument where 0 means false and 1 means true) or a char * (first byte to put the answer to is given by 'data' and allocated space for the reply must be given through 'lu' which at return gives the effective length of the returned string

## ◆ set_info_status()

virtual void libdar::zapette::set_info_status | ( | const std::string & | s | ) |
| override virtual

defines the new contextual value

Note
  inherited class may redefine this call but but must call the parent method to set the value contextual:set_info_status()

Reimplemented from libdar::contextual.

## ◆ skip()

virtual bool libdar::zapette::skip | ( | const infinint & | pos | ) |
| override virtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

## ◆ skippable()

virtual bool libdar::zapette::skippable | ( | skippability | direction,
|  | const infinint & | amount
| ) |  |
| inline override virtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

Definition at line 73 of file zapette.hpp.

The documentation for this class was generated from the following file:

- zapette.hpp